const Vue = require('vue')
    , VueInstance = require('../index')
    , except = require('chai').expect;

describe('VueInstance test', () => {
    const vue = new VueInstance();
    describe('lifecycle', () => {
        it('#beforeCreate', () => { vue.beforeCreate(() => { except('').to.be.empty; }); });
        it('#created', () => { vue.created(() => { except('').to.be.empty }); });
        it('#beforeMount', () => { vue.beforeMount(() => { except('').to.be.empty }); });
        it('#mounted', () => { vue.mounted(() => { except('').to.be.empty }); });
        it('#beforeUpdate', () => { vue.beforeUpdate(() => { except('').to.be.empty }); });
        it('#updated', () => { vue.updated(() => { except('').to.be.empty }); });
        it('beforeDestroy', () => { vue.beforeDestroy(() => { except('').to.be.empty }); });
        it('destroy', () => { vue.destroy(() => { except('').to.be.empty }); });

        it('#多次将函数挂载至生命周期下应该都正常工作', () => {
            let lifecycle = '';
            vue.mounted(() => {
                lifecycle = 'hello ';
            });
            vue.mounted(() => {
                except(lifecycle + 'world').to.be.equal('hello world');
            });
        });
    });

    it('#data多次挂载正常工作', () => {
        vue.data({ msg: 'hello' });
        vue.data({ test: 'world' });
        const vm = new Vue(vue.getInstance());
        let resu = `${vm.msg} ${vm.test}`;
        except(resu).to.be.equal('hello world');
    });
    it('#computed正常工作', () => {
        vue.computed({ computed_hello() { return 'hello' } });
        vue.computed({ computed_world() { return 'world' } });
        vue.mounted(vm => {
            except(`${vm.computed_hello} ${vm.computed_world}`).to.be.eq('hello world');
        });
    });
    it('#methods', () => {
        vue.methods({ sayhello() { return 'hello world'; } });

        vue.mounted(vm => {
            except(vm.sayhello()).to.be.eq('hello world');
        });
    });
});
